root.buttons( {
    button({ }, 3, function () awful.util.spawn(terminal) end),
})

globalkeys = {}

keybind_move_client = {}
keybind_change_tag = {}
taglist_names = "<span color='lightblue'>"
for i = 1, #tag_list do
    char = string.find(tag_list[i].name,tag_list[i].hotkey)
    taglist_names = taglist_names .. string.sub(tag_list[i].name,1,char-1) .. "<span color='yellow'>" .. 
        string.sub(tag_list[i].name,char,char) .. "</span>" ..
        string.sub(tag_list[i].name,char+1,-1) 
        taglist_names = taglist_names .. " - <span color='white'>" .. tag_list[i].comment .. "</span>"
        if i < #tag_list then
            taglist_names = taglist_names .. "\n"
        end
end
taglist_names = taglist_names .. "</span>"

function keybind_add(mytable,ftitle)
    for k, v in pairs(mytable) do
        table.insert(globalkeys,v)
        root.keys(globalkeys)
    end
    if not notify_keychain then
        notify_keychain = naughty.notify({
            title = ftitle,
            text = taglist_names,
            timeout = 0,
            position = "bottom_left",
            bg = "#000000aa",
            width = 200,
            border_width = 0,
        })
    end
end

function keybind_remove(mytable)
    for k, v in pairs(mytable) do
        -- I hope that insert them latest
        table.remove(globalkeys)
        root.keys(globalkeys)
    end
    if notify_keychain then
        naughty.destroy(notify_keychain)
        notify_keychain = nil
    end
end

table.insert(keybind_move_client, key({},"Escape",function()
    keybind_remove(keybind_move_client)
end))

table.insert(keybind_change_tag, key({},"Escape",function()
    keybind_remove(keybind_change_tag)
end))

notify_keychain = nil

for i = 1, #tag_list do

    -- Change the current tag (win+t AFTER hotkey)
    table.insert(keybind_change_tag, key({}, tag_list[i].hotkey,
        function ()
            if tags[i] then
                awful.tag.viewonly(tags[i])
            end
            keybind_remove(keybind_change_tag)
        end)
    )
    table.insert(globalkeys, 
        key({ winkey }, "t", function ()
            keybind_add(keybind_change_tag,"Change tag...")
        end)
    )

    -- Move client to the tag (win+m AFTER hotkey)
    table.insert(keybind_move_client, key({}, tag_list[i].hotkey, 
        function ()
            local sel = client.focus 
            if sel then 
                if tags[i] then 
                    awful.client.movetotag(tags[i]) 
                end 
            end
            keybind_remove(keybind_move_client)
        end)
    )
    table.insert(globalkeys, 
        key({ winkey }, "m", function()
            keybind_add(keybind_move_client,"Move to tag...")
        end)
    )

end

table.insert(globalkeys, key({ modkey }, "Escape", awful.tag.history.restore) )
table.insert(globalkeys, key({ winkey }, "x" , function () main_menu:show() end ))

-- Standard program
table.insert(globalkeys, key({ modkey }, "Return", function () awful.util.spawn(terminal) end))
table.insert(globalkeys, key({ modkey, "Control" }, "r", awesome.restart))
table.insert(globalkeys, key({ modkey, "Shift" }, "q", function () 
        awful.util.spawn("killall newsbeuter irssi iceweasel-bin")
        awful.util.spawn("claws-mail --quit")
        awesome.quit()
    end )
)

-- External programs
table.insert(globalkeys, key({modkey, "Shift"}, "f", function () awful.util.spawn("firefox") end) )
table.insert(globalkeys, key({modkey, "Shift"}, "b", function () awful.util.spawn("transmission") end) )
table.insert(globalkeys, key({modkey, "Shift"}, "m", function () awful.util.spawn("roxterm --profile=Music --class=Music -e mocp",1) end) )
table.insert(globalkeys, key({modkey, "Shift"}, "d", function () awful.util.spawn("roxterm --profile=Doc --class=dox --directory=" .. os.getenv("HOME") .. "/Documents") end) )
table.insert(globalkeys, key({modkey, "Shift"}, "v", function () awful.util.spawn("roxterm --profile=Programming --directory=" .. os.getenv("HOME") .. "/progs") end) )
table.insert(globalkeys, key({modkey, "Shift"}, "p", function () awful.util.spawn("roxterm --profile=PLD --class=pld") end) )

-- Client manipulation
clientkeys = {}
table.insert(clientkeys, key({ modkey }, "m", function (c)
    c.maximized_horizontal = not c.maximized_horizontal
    c.maximized_vertical = not c.maximized_vertical
end) )
table.insert(clientkeys, key({ modkey, "Shift" }, "c", function () client.focus:kill() end) )
table.insert(clientkeys, key({ modkey }, "Tab", function () awful.client.focus.byidx(1); client.focus:raise() end) )
table.insert(clientkeys, key({ modkey, "Shift" }, "Tab", function () awful.client.focus.byidx(-1); client.focus:raise() end) )
table.insert(clientkeys, key({ modkey, "Shift" }, "j", function () awful.client.swap.byidx(1) end) )
table.insert(clientkeys, key({ modkey, "Shift" }, "k", function () awful.client.swap.byidx(-1) end) )
table.insert(clientkeys, key({ modkey, "Control" }, "j", function () awful.screen.focus(1) end) )
table.insert(clientkeys, key({ modkey, "Control" }, "k", function () awful.screen.focus(-1) end) )
table.insert(clientkeys, key({ modkey, "Control" }, "space", awful.client.togglefloating) )
table.insert(clientkeys, key({ modkey, "Control" }, "Return", function () client.focus:swap(awful.client.master()) end) )
table.insert(clientkeys, key({ modkey }, "u", awful.client.urgent.jumpto) )
table.insert(clientkeys, key({ modkey, "Shift" }, "r", function () client.focus:redraw() end) )

-- Layout manipulation
table.insert(globalkeys, key({ modkey }, "l" , function () awful.tag.incmwfact(0.05) end) )
table.insert(globalkeys, key({ modkey }, "h", function () awful.tag.incmwfact(-0.05) end) )
table.insert(globalkeys, key({ modkey, "Shift" }, "h", function () awful.tag.incnmaster(1) end) )
table.insert(globalkeys, key({ modkey, "Shift" }, "l", function () awful.tag.incnmaster(-1) end) )
table.insert(globalkeys, key({ modkey, "Control" }, "h", function () awful.tag.incncol(1) end) )
table.insert(globalkeys, key({ modkey, "Control" }, "l", function () awful.tag.incncol(-1) end) )
table.insert(globalkeys, key({ modkey }, "space", function () awful.layout.inc(layouts, 1) end) )
table.insert(globalkeys, key({ modkey, "Shift" }, "space", function () awful.layout.inc(layouts, -1) end) )

-- Prompt
table.insert(globalkeys, 
    key({ modkey }, "F1", function ()
        awful.prompt.run({ prompt = "Run: " }, mypromptbox, awful.util.spawn, awful.completion.bash,
        os.getenv("HOME") .. "/.cache/awesome/history") 
    end)
    )
table.insert(globalkeys,
    key({ modkey }, "F4", function ()
        awful.prompt.run({ prompt = "Run Lua code: " }, mypromptbox, awful.eval, awful.prompt.bash,
        os.getenv("HOME") .. "/.cache/awesome/history_eval")
    end)
    )
table.insert(globalkeys,
    key({ modkey, "Ctrl" }, "i", function ()
        if mypromptbox.text then
            mypromptbox.text = nil
        else
            mypromptbox.text = nil
            if client.focus.class then
                mypromptbox.text = "Class: " .. client.focus.class .. " "
            end
            if client.focus.instance then
                mypromptbox.text = mypromptbox.text .. "Instance: ".. client.focus.instance .. " "
            end
            if client.focus.role then
                mypromptbox.text = mypromptbox.text .. "Role: ".. client.focus.role
            end
        end
    end)
    )

root.keys(globalkeys)

