
tag_list = {
    { name = "term",    hotkey = "e",   layout = "tile",       comment="Terminal"     },
    { name = "web",     hotkey = "w",   layout = "magnifier",    comment="Web browser"  },
    { name = "irc",     hotkey = "r",   layout = "magnifier",   comment="IRC"},
    { name = "mail",    hotkey = "l",   layout = "magnifier",   comment="Mail client"},
    { name = "news",    hotkey = "n",   layout = "magnifier",         comment="News/mail reader" },
    { name = "music",   hotkey = "m",   layout = "max",          comment="Music player"          },
    { name = "torrent", hotkey = "t",   layout = "tile",       comment="Torrent client"   },
    { name = "utils",   hotkey = "u",   layout = "spiral",       comment="Other utilities"  },
    { name = "games",   hotkey = "g",   layout = "max",          comment="Games"},
    { name = "dox",     hotkey = "d",   layout = "magnifier",    comment="LaTeX, OpenOffice"},
    { name = "dev",     hotkey = "v",   layout = "tile",         comment="Program developing"         },
    { name = "pld",     hotkey = "p",   layout = "magnifier",    comment="PLD developing"    },
    { name = "todo",     hotkey = "o",   layout = "max",         comment="My todos"    },
    { name = "im",     hotkey = "i",   layout = "tileleft",      comment="Instant messaging"   }
}

function get_tag_by_name(des_tag)
    local i
    for i = 1,#tag_list do
        if tag_list[i].name == des_tag then return i
        end
    end
    return -1
end

tags = {}
for tagnumber = 1, #tag_list do
    tags[tagnumber] = tag(tag_list[tagnumber].name)
    tags[tagnumber].screen = 1
    local i
    for i = 1,#layouts do
        if awful.layout.getname(layouts[i]) == tag_list[tagnumber].layout then
            awful.layout.set(
                layouts[i],
                tags[tagnumber]
            )
        end
    end
end

awful.tag.setmwfact(0.8,tags[get_tag_by_name("dox")])
awful.tag.setmwfact(0.7,tags[get_tag_by_name("im")])
tags[1].selected = true

